const path = require('path');
module.exports = {
  entry: "./src/spec.ts",
  output: {
    path: path.resolve(__dirname, 'build'),
    filename: 'integration-tests.js'
  },
  devtool: 'inline-source-map',
  module: {
    rules: [
      {
        test: /\.js$/,
        include: /src/,
        loader: "babel-loader",
        exclude: /node_modules/
      },
      {
        test: /\.ts$/,
        include: [/src/, /_proto/],
        exclude: /node_modules/,
        loader: "ts-loader"
      }
    ]
  },
  resolve: {
    extensions: [".ts", ".js"]
  }
};
